// DialogConfigTab3.cpp : @
//

#include "stdafx.h"
#include "VTC1911_IPK_Utility.h"
#include "DialogConfigTab3.h"
#include "VTC1911_IPK.h"


CDialogConfigTab3 *p_CDialogConfigTab3 = NULL;

void EventSystemShutdown(unsigned char byEvent)
{
	SYSTEMTIME sysTime;
	GetLocalTime(&sysTime);

	CString strEvent;
	switch(byEvent)
	{
	case 0x01: strEvent.Format("%d:%d:%d:%d => Power Button Off", sysTime.wHour, sysTime.wMinute, sysTime.wSecond, sysTime.wMilliseconds); break;
	case 0x02: strEvent.Format("%d:%d:%d:%d => Input Voltage too Low Off", sysTime.wHour, sysTime.wMinute, sysTime.wSecond, sysTime.wMilliseconds); break;
	case 0x03: strEvent.Format("%d:%d:%d:%d => Input Voltage too High Off", sysTime.wHour, sysTime.wMinute, sysTime.wSecond, sysTime.wMilliseconds); break;
	case 0x06: strEvent.Format("%d:%d:%d:%d => Direct Power off", sysTime.wHour, sysTime.wMinute, sysTime.wSecond, sysTime.wMilliseconds); break;
	default: strEvent = ""; break;
	}

	if( p_CDialogConfigTab3 )
	{
		p_CDialogConfigTab3->AddEventSystemShutdown(strEvent);
	}
}

void EventSystemAlarm(unsigned char byEvent)
{
	SYSTEMTIME sysTime;
	GetLocalTime(&sysTime);

	CString strEvent;
	switch(byEvent)
	{
	case 0x01: strEvent.Format("%d:%d:%d:%d => Voltage too Low", sysTime.wHour, sysTime.wMinute, sysTime.wSecond, sysTime.wMilliseconds); break;
	case 0x02: strEvent.Format("%d:%d:%d:%d => Voltage too high", sysTime.wHour, sysTime.wMinute, sysTime.wSecond, sysTime.wMilliseconds); break;
	default: strEvent = ""; break;
	}

	if( p_CDialogConfigTab3 )
	{
		p_CDialogConfigTab3->AddEventSystemAlarm(strEvent);
	}
}


// CDialogConfigTab3 ܤ

IMPLEMENT_DYNAMIC(CDialogConfigTab3, CDialog)

CDialogConfigTab3::CDialogConfigTab3(CWnd* pParent /*=NULL*/)
	: CDialog(CDialogConfigTab3::IDD, pParent)
{

}

CDialogConfigTab3::~CDialogConfigTab3()
{
	RegisterCallBackFunction(NULL, NULL);
	p_CDialogConfigTab3 = NULL;
}

void CDialogConfigTab3::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST1, m_CListBox_SystemShutdown);
	DDX_Control(pDX, IDC_LIST2, m_CListBox_SystemAlarm);
}


BEGIN_MESSAGE_MAP(CDialogConfigTab3, CDialog)
END_MESSAGE_MAP()


// CDialogConfigTab3 TBz`

BOOL CDialogConfigTab3::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO: Add extra initialization here

	p_CDialogConfigTab3 = this;

	RegisterCallBackFunction(
		EventSystemShutdown,
		EventSystemAlarm);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDialogConfigTab3::AddEventSystemShutdown(CString strEvent)
{
	int nCount = m_CListBox_SystemShutdown.GetCount();
	if( nCount > 10 )
	{
		m_CListBox_SystemShutdown.DeleteString(0);
	}

	nCount = m_CListBox_SystemShutdown.GetCount();
	m_CListBox_SystemShutdown.InsertString(nCount, strEvent);
}

void CDialogConfigTab3::AddEventSystemAlarm(CString strEvent)
{
	int nCount = m_CListBox_SystemAlarm.GetCount();
	if( nCount > 10 )
	{
		m_CListBox_SystemAlarm.DeleteString(0);
	}

	nCount = m_CListBox_SystemAlarm.GetCount();
	m_CListBox_SystemAlarm.InsertString(nCount, strEvent);
}
