// VTC1911-IPK API V1.0 2018/01/23
#define VTC1911_IPK_API extern "C" __declspec(dllimport)

VTC1911_IPK_API void Get_DLL_Version(int *pnMajorVersion, int *pnMinorVersion);
VTC1911_IPK_API bool Get_BIOS_Version(char *szBIOS_Ver, int nLen);
VTC1911_IPK_API bool Get_BIOS_Version_W(wchar_t *szBIOS_Ver, int nLen);

VTC1911_IPK_API int  Connect();
VTC1911_IPK_API void Disconnect();

VTC1911_IPK_API int  GetMCUVersion(int *pnMCUVersion);
VTC1911_IPK_API int  GetOSControl(int *pnStatus);
VTC1911_IPK_API int  GetIgnitionStatus(int *pnIgnitionStatus);
VTC1911_IPK_API int  GetSupplyVoltage(int *pnSupplyVoltage);
VTC1911_IPK_API int  GetPowerType(int *pnPowerType);
VTC1911_IPK_API int  GetDelayTimeOption(int *pnPowerOff, int *pnPowerOn, int *pnDelayOffEnable, int *pnDelayOnEnable);
VTC1911_IPK_API int  GetStartupShutdownOption(int *pnStartupShutdownOption);
VTC1911_IPK_API int  GetAlarmTimer(int *pnHour, int *pnMin, int *pnSec);
VTC1911_IPK_API int  GetWWANStatus(int *pnWWAN_Enable, int *pnWWAN_Wakeup_Enable);
VTC1911_IPK_API int  GetWiFiStatus(int *pnWiFiStatus);
VTC1911_IPK_API int  GetLANStatus(int *pnLANStatus);
VTC1911_IPK_API int  GetRTCStatus(int *pnRTCStatus);
VTC1911_IPK_API int  GetMDOStatus(int *pnMDO1, int *pnMDO2, int *pnMDO3);
VTC1911_IPK_API int  GetMDIStatus(int *pnMDI1, int *pnMDI2, int *pnMDI3);
VTC1911_IPK_API int  GetSIMCardStatus(int *pnSIMCard);

VTC1911_IPK_API int  SetBootMode(int nBootMode);
VTC1911_IPK_API int  SetOSControl(int nOSControl);
VTC1911_IPK_API int  SetRTCTimer(int nHour, int nMin, int nSec);
VTC1911_IPK_API int  SetDelayTimeOption(int nPowerOffDelayTime, int nPowerOffDelayTime_Enable, int nPowerOnDelayTime, int nPowerOnDelayTime_Enable);
VTC1911_IPK_API int  SetStartupShutdownOption(int nOption);
VTC1911_IPK_API int  SetAlarmTimer(int nHour, int nMin, int nSec);
VTC1911_IPK_API int  SetWWANControl(int nWWAN_Enable, int nWWAN_Wakeup_Enable);
VTC1911_IPK_API int  SetWiFiControl(int nEnable);
VTC1911_IPK_API int  SetLANControl(int nEnable);
VTC1911_IPK_API int  SetRTCControl(int nEnable);
VTC1911_IPK_API int  SetFlashUpdate();
VTC1911_IPK_API int  SetMDOControl(int nMDO1, int nMDO2, int nMDO3);
VTC1911_IPK_API int  SetSIMCardSelect(int nSIMCardSelect);

// ================================================================================================================================================
typedef void (*EventSystemShutdown_CallBack)(unsigned char byEvent);
typedef void (*EventSystemAlarm_CallBack)(unsigned char byEvent);

VTC1911_IPK_API void RegisterCallBackFunction(
	EventSystemShutdown_CallBack fnESS,
	EventSystemAlarm_CallBack    fnESA);
